import { ActionType, IMaterialItem, IWebRuntimeAppData, IDynamicValue, IComponentLibEntry } from '../../weapps-core';
import { BuildType, IFileCodeMap } from '../types/common';
import { DEPLOY_MODE, RUNTIME } from '../../types';
import { IPlatformApp, IPlatformSubApp } from '@cloudbase/cals';
import { BuildAppProps } from '.';
export declare function runGenerateCore(props: {
    appBuildDir: string;
    cals: IPlatformApp;
    sub_cals?: IPlatformSubApp[];
    appData: IWebRuntimeAppData;
    dependencies: IMaterialItem[];
    appKey: string;
    buildTypeList: BuildType[];
    basename: string;
    deployOptions: {
        mode: DEPLOY_MODE;
        version?: string;
    };
    runtimeOptions: {
        mode: DEPLOY_MODE;
    };
    runtime: RUNTIME;
    ignoreInstall: boolean;
    extraData: {
        isComposite: boolean;
        compProps: any;
    };
    i18nConfig: any;
    fileCodeMap: IFileCodeMap;
    isSandbox: boolean;
    _indexPage: boolean;
    processCssUnit?: 'px' | 'rpx' | 'rem';
    rpxCalcRoot?: string;
    isPrivateMode?: boolean;
    expirationStartTimesnap?: number;
    enableAd?: boolean;
    usedComps?: BuildAppProps['usedComps'];
    privatelinkConfig?: BuildAppProps['privatelinkConfig'];
}): Promise<void>;
export interface IOriginKeyInfo {
    sourceKey: string;
    name: string;
    materialName: string;
    materialVersion: string;
    key: string;
    variableName: string;
    type?: ActionType;
    isComposite?: boolean;
    isPlainProps?: boolean;
    entries?: IComponentLibEntry;
}
export declare enum EfilterType {
    USECOMPONENTSET = "useComponentSet",
    USECOMPONENTOBJECT = "useComponentObject"
}
export declare function isSlot(comp: {
    path?: string;
    ['x-props']?: Object;
}): boolean | "" | undefined;
export declare function generateDataBind(bind: IDynamicValue): string;
export declare function getControlMap(dependencies: IMaterialItem[], filterType: EfilterType.USECOMPONENTSET, usedCmpsObject: Required<BuildAppProps>['usedComps']): {};
export declare function getControlMap(dependencies: IMaterialItem[], filterType: EfilterType.USECOMPONENTOBJECT, usedCmpsObject: {
    moduleName: string;
    name: string;
    key: string;
    var: string;
    moduleNameVar: string;
    version: string;
    entries?: IComponentLibEntry;
    isComposite?: boolean;
    isPlainProps?: boolean;
}[]): {};
export declare function generateFilesFromTemplate({ templatesData, fileCodeMap, baseTargetPath, }: {
    templatesData: {
        [key: string]: Object;
    };
    fileCodeMap?: {
        [filePath: string]: {
            code: string;
        };
    };
    baseTargetPath?: string;
}): {
    [filePath: string]: {
        code: string;
    };
};
export declare function getDependenciesMap(dependencies: any, buildTypeList: any, relativePath: any): {
    useMaterialActions: IOriginKeyInfo[];
    actionsString: string[];
};
